/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/communityGalleriesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a CommunityGalleries. */
var CommunityGalleries = /** @class */ (function () {
    /**
     * Create a CommunityGalleries.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    function CommunityGalleries(client) {
        this.client = client;
    }
    CommunityGalleries.prototype.get = function (location, publicGalleryName, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            publicGalleryName: publicGalleryName,
            options: options
        }, getOperationSpec, callback);
    };
    return CommunityGalleries;
}());
export { CommunityGalleries };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/communityGalleries/{publicGalleryName}",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.location0,
        Parameters.publicGalleryName
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.CommunityGallery
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=communityGalleries.js.map