import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { ComputeManagementClientContext } from "../computeManagementClientContext";
/** Class representing a CommunityGalleryImageVersions. */
export declare class CommunityGalleryImageVersions {
    private readonly client;
    /**
     * Create a CommunityGalleryImageVersions.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    constructor(client: ComputeManagementClientContext);
    /**
     * Get a community gallery image version.
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param galleryImageName The name of the community gallery image definition.
     * @param galleryImageVersionName The name of the community gallery image version. Needs to follow
     * semantic version name pattern: The allowed characters are digit and period. Digits must be
     * within the range of a 32-bit integer. Format: <MajorVersion>.<MinorVersion>.<Patch>
     * @param [options] The optional parameters
     * @returns Promise<Models.CommunityGalleryImageVersionsGetResponse>
     */
    get(location: string, publicGalleryName: string, galleryImageName: string, galleryImageVersionName: string, options?: msRest.RequestOptionsBase): Promise<Models.CommunityGalleryImageVersionsGetResponse>;
    /**
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param galleryImageName The name of the community gallery image definition.
     * @param galleryImageVersionName The name of the community gallery image version. Needs to follow
     * semantic version name pattern: The allowed characters are digit and period. Digits must be
     * within the range of a 32-bit integer. Format: <MajorVersion>.<MinorVersion>.<Patch>
     * @param callback The callback
     */
    get(location: string, publicGalleryName: string, galleryImageName: string, galleryImageVersionName: string, callback: msRest.ServiceCallback<Models.CommunityGalleryImageVersion>): void;
    /**
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param galleryImageName The name of the community gallery image definition.
     * @param galleryImageVersionName The name of the community gallery image version. Needs to follow
     * semantic version name pattern: The allowed characters are digit and period. Digits must be
     * within the range of a 32-bit integer. Format: <MajorVersion>.<MinorVersion>.<Patch>
     * @param options The optional parameters
     * @param callback The callback
     */
    get(location: string, publicGalleryName: string, galleryImageName: string, galleryImageVersionName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.CommunityGalleryImageVersion>): void;
}
//# sourceMappingURL=communityGalleryImageVersions.d.ts.map