/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import * as Mappers from "../models/communityGalleryImagesMappers";
import * as Parameters from "../models/parameters";
import { ComputeManagementClientContext } from "../computeManagementClientContext";

/** Class representing a CommunityGalleryImages. */
export class CommunityGalleryImages {
  private readonly client: ComputeManagementClientContext;

  /**
   * Create a CommunityGalleryImages.
   * @param {ComputeManagementClientContext} client Reference to the service client.
   */
  constructor(client: ComputeManagementClientContext) {
    this.client = client;
  }

  /**
   * Get a community gallery image.
   * @param location Resource location.
   * @param publicGalleryName The public name of the community gallery.
   * @param galleryImageName The name of the community gallery image definition.
   * @param [options] The optional parameters
   * @returns Promise<Models.CommunityGalleryImagesGetResponse>
   */
  get(location: string, publicGalleryName: string, galleryImageName: string, options?: msRest.RequestOptionsBase): Promise<Models.CommunityGalleryImagesGetResponse>;
  /**
   * @param location Resource location.
   * @param publicGalleryName The public name of the community gallery.
   * @param galleryImageName The name of the community gallery image definition.
   * @param callback The callback
   */
  get(location: string, publicGalleryName: string, galleryImageName: string, callback: msRest.ServiceCallback<Models.CommunityGalleryImage>): void;
  /**
   * @param location Resource location.
   * @param publicGalleryName The public name of the community gallery.
   * @param galleryImageName The name of the community gallery image definition.
   * @param options The optional parameters
   * @param callback The callback
   */
  get(location: string, publicGalleryName: string, galleryImageName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.CommunityGalleryImage>): void;
  get(location: string, publicGalleryName: string, galleryImageName: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.CommunityGalleryImage>, callback?: msRest.ServiceCallback<Models.CommunityGalleryImage>): Promise<Models.CommunityGalleryImagesGetResponse> {
    return this.client.sendOperationRequest(
      {
        location,
        publicGalleryName,
        galleryImageName,
        options
      },
      getOperationSpec,
      callback) as Promise<Models.CommunityGalleryImagesGetResponse>;
  }
}

// Operation Specifications
const serializer = new msRest.Serializer(Mappers);
const getOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/communityGalleries/{publicGalleryName}/images/{galleryImageName}",
  urlParameters: [
    Parameters.subscriptionId,
    Parameters.location0,
    Parameters.publicGalleryName,
    Parameters.galleryImageName
  ],
  queryParameters: [
    Parameters.apiVersion0
  ],
  headerParameters: [
    Parameters.acceptLanguage
  ],
  responses: {
    200: {
      bodyMapper: Mappers.CommunityGalleryImage
    },
    default: {
      bodyMapper: Mappers.CloudError
    }
  },
  serializer
};
