import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a AvailableDelegations. */
export declare class AvailableDelegations {
    private readonly client;
    /**
     * Create a AvailableDelegations.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Gets all of the available subnet delegations for this subscription in this region.
     * @param location The location of the subnet.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailableDelegationsListResponse>
     */
    list(location: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailableDelegationsListResponse>;
    /**
     * @param location The location of the subnet.
     * @param callback The callback
     */
    list(location: string, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
    /**
     * @param location The location of the subnet.
     * @param options The optional parameters
     * @param callback The callback
     */
    list(location: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
    /**
     * Gets all of the available subnet delegations for this subscription in this region.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailableDelegationsListNextResponse>
     */
    listNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailableDelegationsListNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
}
//# sourceMappingURL=availableDelegations.d.ts.map