/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/availableResourceGroupDelegationsMappers";
import * as Parameters from "../models/parameters";
/** Class representing a AvailableResourceGroupDelegations. */
var AvailableResourceGroupDelegations = /** @class */ (function () {
    /**
     * Create a AvailableResourceGroupDelegations.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function AvailableResourceGroupDelegations(client) {
        this.client = client;
    }
    AvailableResourceGroupDelegations.prototype.list = function (location, resourceGroupName, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            resourceGroupName: resourceGroupName,
            options: options
        }, listOperationSpec, callback);
    };
    AvailableResourceGroupDelegations.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return AvailableResourceGroupDelegations;
}());
export { AvailableResourceGroupDelegations };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/locations/{location}/availableDelegations",
    urlParameters: [
        Parameters.location0,
        Parameters.resourceGroupName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.AvailableDelegationsResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.AvailableDelegationsResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=availableResourceGroupDelegations.js.map