/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __assign } from "tslib";
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/firewallPolicyIdpsSignaturesFilterValuesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a FirewallPolicyIdpsSignaturesFilterValues. */
var FirewallPolicyIdpsSignaturesFilterValues = /** @class */ (function () {
    /**
     * Create a FirewallPolicyIdpsSignaturesFilterValues.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function FirewallPolicyIdpsSignaturesFilterValues(client) {
        this.client = client;
    }
    FirewallPolicyIdpsSignaturesFilterValues.prototype.list = function (parameters, resourceGroupName, firewallPolicyName, options, callback) {
        return this.client.sendOperationRequest({
            parameters: parameters,
            resourceGroupName: resourceGroupName,
            firewallPolicyName: firewallPolicyName,
            options: options
        }, listOperationSpec, callback);
    };
    return FirewallPolicyIdpsSignaturesFilterValues;
}());
export { FirewallPolicyIdpsSignaturesFilterValues };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "POST",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/firewallPolicies/{firewallPolicyName}/listIdpsFilterOptions",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.firewallPolicyName,
        Parameters.subscriptionId
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.SignatureOverridesFilterValuesQuery), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.SignatureOverridesFilterValuesResponse
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=firewallPolicyIdpsSignaturesFilterValues.js.map