/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __assign } from "tslib";
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/firewallPolicyIdpsSignaturesOverridesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a FirewallPolicyIdpsSignaturesOverrides. */
var FirewallPolicyIdpsSignaturesOverrides = /** @class */ (function () {
    /**
     * Create a FirewallPolicyIdpsSignaturesOverrides.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function FirewallPolicyIdpsSignaturesOverrides(client) {
        this.client = client;
    }
    FirewallPolicyIdpsSignaturesOverrides.prototype.patch = function (parameters, resourceGroupName, firewallPolicyName, options, callback) {
        return this.client.sendOperationRequest({
            parameters: parameters,
            resourceGroupName: resourceGroupName,
            firewallPolicyName: firewallPolicyName,
            options: options
        }, patchOperationSpec, callback);
    };
    FirewallPolicyIdpsSignaturesOverrides.prototype.put = function (parameters, resourceGroupName, firewallPolicyName, options, callback) {
        return this.client.sendOperationRequest({
            parameters: parameters,
            resourceGroupName: resourceGroupName,
            firewallPolicyName: firewallPolicyName,
            options: options
        }, putOperationSpec, callback);
    };
    FirewallPolicyIdpsSignaturesOverrides.prototype.get = function (resourceGroupName, firewallPolicyName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            firewallPolicyName: firewallPolicyName,
            options: options
        }, getOperationSpec, callback);
    };
    FirewallPolicyIdpsSignaturesOverrides.prototype.list = function (resourceGroupName, firewallPolicyName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            firewallPolicyName: firewallPolicyName,
            options: options
        }, listOperationSpec, callback);
    };
    return FirewallPolicyIdpsSignaturesOverrides;
}());
export { FirewallPolicyIdpsSignaturesOverrides };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var patchOperationSpec = {
    httpMethod: "PATCH",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/firewallPolicies/{firewallPolicyName}/signatureOverrides/default",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.firewallPolicyName,
        Parameters.subscriptionId
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.SignaturesOverrides), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.SignaturesOverrides
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var putOperationSpec = {
    httpMethod: "PUT",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/firewallPolicies/{firewallPolicyName}/signatureOverrides/default",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.firewallPolicyName,
        Parameters.subscriptionId
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.SignaturesOverrides), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.SignaturesOverrides
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/firewallPolicies/{firewallPolicyName}/signatureOverrides/default",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.firewallPolicyName,
        Parameters.subscriptionId
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SignaturesOverrides
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/firewallPolicies/{firewallPolicyName}/signatureOverrides",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.firewallPolicyName,
        Parameters.subscriptionId
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SignaturesOverridesList
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=firewallPolicyIdpsSignaturesOverrides.js.map