/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/loadBalancerNetworkInterfacesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a LoadBalancerNetworkInterfaces. */
var LoadBalancerNetworkInterfaces = /** @class */ (function () {
    /**
     * Create a LoadBalancerNetworkInterfaces.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function LoadBalancerNetworkInterfaces(client) {
        this.client = client;
    }
    LoadBalancerNetworkInterfaces.prototype.list = function (resourceGroupName, loadBalancerName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            loadBalancerName: loadBalancerName,
            options: options
        }, listOperationSpec, callback);
    };
    LoadBalancerNetworkInterfaces.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return LoadBalancerNetworkInterfaces;
}());
export { LoadBalancerNetworkInterfaces };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/networkInterfaces",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.loadBalancerName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.NetworkInterfaceListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.NetworkInterfaceListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=loadBalancerNetworkInterfaces.js.map