import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a ServiceTags. */
export declare class ServiceTags {
    private readonly client;
    /**
     * Create a ServiceTags.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Gets a list of service tag information resources.
     * @param location The location that will be used as a reference for version (not as a filter based
     * on location, you will get the list of service tags with prefix details across all regions but
     * limited to the cloud that your subscription belongs to).
     * @param [options] The optional parameters
     * @returns Promise<Models.ServiceTagsListResponse>
     */
    list(location: string, options?: msRest.RequestOptionsBase): Promise<Models.ServiceTagsListResponse>;
    /**
     * @param location The location that will be used as a reference for version (not as a filter based
     * on location, you will get the list of service tags with prefix details across all regions but
     * limited to the cloud that your subscription belongs to).
     * @param callback The callback
     */
    list(location: string, callback: msRest.ServiceCallback<Models.ServiceTagsListResult>): void;
    /**
     * @param location The location that will be used as a reference for version (not as a filter based
     * on location, you will get the list of service tags with prefix details across all regions but
     * limited to the cloud that your subscription belongs to).
     * @param options The optional parameters
     * @param callback The callback
     */
    list(location: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.ServiceTagsListResult>): void;
}
//# sourceMappingURL=serviceTags.d.ts.map