import * as msRest from "@azure/ms-rest-js";
import * as msRestAzure from "@azure/ms-rest-azure-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a VpnServerConfigurationsAssociatedWithVirtualWan. */
export declare class VpnServerConfigurationsAssociatedWithVirtualWan {
    private readonly client;
    /**
     * Create a VpnServerConfigurationsAssociatedWithVirtualWan.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Gives the list of VpnServerConfigurations associated with Virtual Wan in a resource group.
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN whose associated VpnServerConfigurations is
     * needed.
     * @param [options] The optional parameters
     * @returns Promise<Models.VpnServerConfigurationsAssociatedWithVirtualWanListResponse>
     */
    list(resourceGroupName: string, virtualWANName: string, options?: msRest.RequestOptionsBase): Promise<Models.VpnServerConfigurationsAssociatedWithVirtualWanListResponse>;
    /**
     * Gives the list of VpnServerConfigurations associated with Virtual Wan in a resource group.
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN whose associated VpnServerConfigurations is
     * needed.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginList(resourceGroupName: string, virtualWANName: string, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
}
//# sourceMappingURL=vpnServerConfigurationsAssociatedWithVirtualWan.d.ts.map