/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/vpnServerConfigurationsAssociatedWithVirtualWanMappers";
import * as Parameters from "../models/parameters";
/** Class representing a VpnServerConfigurationsAssociatedWithVirtualWan. */
var VpnServerConfigurationsAssociatedWithVirtualWan = /** @class */ (function () {
    /**
     * Create a VpnServerConfigurationsAssociatedWithVirtualWan.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function VpnServerConfigurationsAssociatedWithVirtualWan(client) {
        this.client = client;
    }
    /**
     * Gives the list of VpnServerConfigurations associated with Virtual Wan in a resource group.
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN whose associated VpnServerConfigurations is
     * needed.
     * @param [options] The optional parameters
     * @returns Promise<Models.VpnServerConfigurationsAssociatedWithVirtualWanListResponse>
     */
    VpnServerConfigurationsAssociatedWithVirtualWan.prototype.list = function (resourceGroupName, virtualWANName, options) {
        return this.beginList(resourceGroupName, virtualWANName, options)
            .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
    };
    /**
     * Gives the list of VpnServerConfigurations associated with Virtual Wan in a resource group.
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN whose associated VpnServerConfigurations is
     * needed.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    VpnServerConfigurationsAssociatedWithVirtualWan.prototype.beginList = function (resourceGroupName, virtualWANName, options) {
        return this.client.sendLRORequest({
            resourceGroupName: resourceGroupName,
            virtualWANName: virtualWANName,
            options: options
        }, beginListOperationSpec, options);
    };
    return VpnServerConfigurationsAssociatedWithVirtualWan;
}());
export { VpnServerConfigurationsAssociatedWithVirtualWan };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var beginListOperationSpec = {
    httpMethod: "POST",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/virtualWans/{virtualWANName}/vpnServerConfigurations",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.resourceGroupName,
        Parameters.virtualWANName0
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.VpnServerConfigurationsResponse
        },
        202: {},
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=vpnServerConfigurationsAssociatedWithVirtualWan.js.map