/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __assign } from "tslib";
import { CloudErrorMapper, BaseResourceMapper } from "@azure/ms-rest-azure-js";
export var CloudError = CloudErrorMapper;
export var BaseResource = BaseResourceMapper;
export var Resource = {
    serializedName: "Resource",
    type: {
        name: "Composite",
        className: "Resource",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var TrackedResource = {
    serializedName: "TrackedResource",
    type: {
        name: "Composite",
        className: "TrackedResource",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PrivateZone = {
    serializedName: "PrivateZone",
    type: {
        name: "Composite",
        className: "PrivateZone",
        modelProperties: __assign(__assign({}, TrackedResource.type.modelProperties), { etag: {
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, maxNumberOfRecordSets: {
                readOnly: true,
                serializedName: "properties.maxNumberOfRecordSets",
                type: {
                    name: "Number"
                }
            }, numberOfRecordSets: {
                readOnly: true,
                serializedName: "properties.numberOfRecordSets",
                type: {
                    name: "Number"
                }
            }, maxNumberOfVirtualNetworkLinks: {
                readOnly: true,
                serializedName: "properties.maxNumberOfVirtualNetworkLinks",
                type: {
                    name: "Number"
                }
            }, numberOfVirtualNetworkLinks: {
                readOnly: true,
                serializedName: "properties.numberOfVirtualNetworkLinks",
                type: {
                    name: "Number"
                }
            }, maxNumberOfVirtualNetworkLinksWithRegistration: {
                readOnly: true,
                serializedName: "properties.maxNumberOfVirtualNetworkLinksWithRegistration",
                type: {
                    name: "Number"
                }
            }, numberOfVirtualNetworkLinksWithRegistration: {
                readOnly: true,
                serializedName: "properties.numberOfVirtualNetworkLinksWithRegistration",
                type: {
                    name: "Number"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            } })
    }
};
export var SubResource = {
    serializedName: "SubResource",
    type: {
        name: "Composite",
        className: "SubResource",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkLink = {
    serializedName: "VirtualNetworkLink",
    type: {
        name: "Composite",
        className: "VirtualNetworkLink",
        modelProperties: __assign(__assign({}, TrackedResource.type.modelProperties), { etag: {
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, virtualNetwork: {
                serializedName: "properties.virtualNetwork",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, registrationEnabled: {
                serializedName: "properties.registrationEnabled",
                type: {
                    name: "Boolean"
                }
            }, virtualNetworkLinkState: {
                readOnly: true,
                serializedName: "properties.virtualNetworkLinkState",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ARecord = {
    serializedName: "ARecord",
    type: {
        name: "Composite",
        className: "ARecord",
        modelProperties: {
            ipv4Address: {
                serializedName: "ipv4Address",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AaaaRecord = {
    serializedName: "AaaaRecord",
    type: {
        name: "Composite",
        className: "AaaaRecord",
        modelProperties: {
            ipv6Address: {
                serializedName: "ipv6Address",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CnameRecord = {
    serializedName: "CnameRecord",
    type: {
        name: "Composite",
        className: "CnameRecord",
        modelProperties: {
            cname: {
                serializedName: "cname",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var MxRecord = {
    serializedName: "MxRecord",
    type: {
        name: "Composite",
        className: "MxRecord",
        modelProperties: {
            preference: {
                serializedName: "preference",
                type: {
                    name: "Number"
                }
            },
            exchange: {
                serializedName: "exchange",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PtrRecord = {
    serializedName: "PtrRecord",
    type: {
        name: "Composite",
        className: "PtrRecord",
        modelProperties: {
            ptrdname: {
                serializedName: "ptrdname",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SoaRecord = {
    serializedName: "SoaRecord",
    type: {
        name: "Composite",
        className: "SoaRecord",
        modelProperties: {
            host: {
                serializedName: "host",
                type: {
                    name: "String"
                }
            },
            email: {
                serializedName: "email",
                type: {
                    name: "String"
                }
            },
            serialNumber: {
                serializedName: "serialNumber",
                type: {
                    name: "Number"
                }
            },
            refreshTime: {
                serializedName: "refreshTime",
                type: {
                    name: "Number"
                }
            },
            retryTime: {
                serializedName: "retryTime",
                type: {
                    name: "Number"
                }
            },
            expireTime: {
                serializedName: "expireTime",
                type: {
                    name: "Number"
                }
            },
            minimumTtl: {
                serializedName: "minimumTtl",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var SrvRecord = {
    serializedName: "SrvRecord",
    type: {
        name: "Composite",
        className: "SrvRecord",
        modelProperties: {
            priority: {
                serializedName: "priority",
                type: {
                    name: "Number"
                }
            },
            weight: {
                serializedName: "weight",
                type: {
                    name: "Number"
                }
            },
            port: {
                serializedName: "port",
                type: {
                    name: "Number"
                }
            },
            target: {
                serializedName: "target",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var TxtRecord = {
    serializedName: "TxtRecord",
    type: {
        name: "Composite",
        className: "TxtRecord",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var ProxyResource = {
    serializedName: "ProxyResource",
    type: {
        name: "Composite",
        className: "ProxyResource",
        modelProperties: __assign({}, Resource.type.modelProperties)
    }
};
export var RecordSet = {
    serializedName: "RecordSet",
    type: {
        name: "Composite",
        className: "RecordSet",
        modelProperties: __assign(__assign({}, ProxyResource.type.modelProperties), { etag: {
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, metadata: {
                serializedName: "properties.metadata",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, ttl: {
                serializedName: "properties.ttl",
                type: {
                    name: "Number"
                }
            }, fqdn: {
                readOnly: true,
                serializedName: "properties.fqdn",
                type: {
                    name: "String"
                }
            }, isAutoRegistered: {
                readOnly: true,
                serializedName: "properties.isAutoRegistered",
                type: {
                    name: "Boolean"
                }
            }, aRecords: {
                serializedName: "properties.aRecords",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ARecord"
                        }
                    }
                }
            }, aaaaRecords: {
                serializedName: "properties.aaaaRecords",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AaaaRecord"
                        }
                    }
                }
            }, cnameRecord: {
                serializedName: "properties.cnameRecord",
                type: {
                    name: "Composite",
                    className: "CnameRecord"
                }
            }, mxRecords: {
                serializedName: "properties.mxRecords",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "MxRecord"
                        }
                    }
                }
            }, ptrRecords: {
                serializedName: "properties.ptrRecords",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PtrRecord"
                        }
                    }
                }
            }, soaRecord: {
                serializedName: "properties.soaRecord",
                type: {
                    name: "Composite",
                    className: "SoaRecord"
                }
            }, srvRecords: {
                serializedName: "properties.srvRecords",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SrvRecord"
                        }
                    }
                }
            }, txtRecords: {
                serializedName: "properties.txtRecords",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TxtRecord"
                        }
                    }
                }
            } })
    }
};
export var PrivateZoneListResult = {
    serializedName: "PrivateZoneListResult",
    type: {
        name: "Composite",
        className: "PrivateZoneListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateZone"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkLinkListResult = {
    serializedName: "VirtualNetworkLinkListResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkLinkListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkLink"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RecordSetListResult = {
    serializedName: "RecordSetListResult",
    type: {
        name: "Composite",
        className: "RecordSetListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RecordSet"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
//# sourceMappingURL=mappers.js.map