import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { ResourceManagementClientContext } from "../resourceManagementClientContext";
/** Class representing a ProviderResourceTypes. */
export declare class ProviderResourceTypes {
    private readonly client;
    /**
     * Create a ProviderResourceTypes.
     * @param {ResourceManagementClientContext} client Reference to the service client.
     */
    constructor(client: ResourceManagementClientContext);
    /**
     * List the resource types for a specified resource provider.
     * @param resourceProviderNamespace The namespace of the resource provider.
     * @param [options] The optional parameters
     * @returns Promise<Models.ProviderResourceTypesListResponse>
     */
    list(resourceProviderNamespace: string, options?: Models.ProviderResourceTypesListOptionalParams): Promise<Models.ProviderResourceTypesListResponse>;
    /**
     * @param resourceProviderNamespace The namespace of the resource provider.
     * @param callback The callback
     */
    list(resourceProviderNamespace: string, callback: msRest.ServiceCallback<Models.ProviderResourceTypeListResult>): void;
    /**
     * @param resourceProviderNamespace The namespace of the resource provider.
     * @param options The optional parameters
     * @param callback The callback
     */
    list(resourceProviderNamespace: string, options: Models.ProviderResourceTypesListOptionalParams, callback: msRest.ServiceCallback<Models.ProviderResourceTypeListResult>): void;
}
//# sourceMappingURL=providerResourceTypes.d.ts.map