/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import * as msRest from "@azure/ms-rest-js";
import { TokenCredential } from "@azure/core-auth";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { ResourceManagementClientContext } from "./resourceManagementClientContext";

class ResourceManagementClient extends ResourceManagementClientContext {
  // Operation groups
  operations: operations.Operations;
  deployments: operations.Deployments;
  providers: operations.Providers;
  providerResourceTypes: operations.ProviderResourceTypes;
  resources: operations.Resources;
  resourceGroups: operations.ResourceGroups;
  tags: operations.TagsOperations;
  deploymentOperations: operations.DeploymentOperations;

  /**
   * Initializes a new instance of the ResourceManagementClient class.
   * @param credentials Credentials needed for the client to connect to Azure. Credentials
   * implementing the TokenCredential interface from the @azure/identity package are recommended. For
   * more information about these credentials, see
   * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
   * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
   * @azure/ms-rest-browserauth are also supported.
   * @param subscriptionId The ID of the target subscription.
   * @param [options] The parameter options
   */
  constructor(
    credentials: msRest.ServiceClientCredentials | TokenCredential,
    subscriptionId: string,
    options?: Models.ResourceManagementClientOptions
  ) {
    super(credentials, subscriptionId, options);
    this.operations = new operations.Operations(this);
    this.deployments = new operations.Deployments(this);
    this.providers = new operations.Providers(this);
    this.providerResourceTypes = new operations.ProviderResourceTypes(this);
    this.resources = new operations.Resources(this);
    this.resourceGroups = new operations.ResourceGroups(this);
    this.tags = new operations.TagsOperations(this);
    this.deploymentOperations = new operations.DeploymentOperations(this);
  }
}

// Operation Specifications

export {
  ResourceManagementClient,
  ResourceManagementClientContext,
  Models as ResourceManagementModels,
  Mappers as ResourceManagementMappers
};
export * from "./operations";
